//////////////////////////////////////////////////////////////////////
//
//  DMLB.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2001. All rights reserved.         
//  
//  Contents:
//      Generic #define constants for DbeInfo(), DbInfo() and FieldInfo()
//   
//////////////////////////////////////////////////////////////////////

// dmlb.ch is not included
#ifndef  _DMLB_CH              

//
// Generic defines relating to the database kernel
//
#define DMLB_FILENAME           0x01
#define DMLB_QUALIFIED_FILENAME 0x02

//
// Defines for DMLB components
//
#define COMPONENT_DATA       1
#define COMPONENT_ORDER      2
#define COMPONENT_RELATION   3
#define COMPONENT_DICTIONARY 4

//
// DBE defines to be used for DbeInfo()
//
// Name of the database engine
#define DBE_NAME             1 
// Version of DBE
#define DBE_VERSION          2 
// Producer of DBE
#define DBE_MANUFACTURER     3 
// Supported data types
#define DBE_DATATYPES        4 
// Default file extension
#define DBE_EXTENSION        5 
// Offset for DBE specific defines
#define DBE_USER          1000 


//
// DBO defines to be used for DbInfo()
//
// File name of database
#define DBO_FILENAME         1 
// Alias of work area
#define DBO_ALIAS            2 
// Number of relations
#define DBO_RELATIONS        3 
// Number of orders
#define DBO_ORDERS           4 
// .T. if DBO is in shared mode
#define DBO_SHARED           5 
// .T. if storage is located on a remote drive
#define DBO_REMOTE           6 
// Return Name of DBE responsive of this DBO
#define DBO_DBENAME          7 
// .T. data is managed on the server side (Client/Server)
#define DBO_SERVER           8

//
// FLD_.. defines to be used for  FieldInfo()
//
// Data type of field at language level as character token
#define FLD_TYPE                  1 
// Data type of field at language level as numeric
#define FLD_TYPE_AS_NUMERIC       2
// Native data type at DBE level as character token
#define FLD_NATIVETYPE            3
// Native data type at DBE level as numeric
#define FLD_NATIVETYPE_AS_NUMERIC 4 
// Field length
#define FLD_LEN                   5
// Number of decimal places
#define FLD_DEC                   6

//
// Defines for notifications from the work area (database object)
//
// Database will be closed
#define DBO_CLOSE_REQUEST    1 
// A bulk operation will commence
#define DBO_BULK_REQUEST     2 
// A bulk operation is finished
#define DBO_BULK_COMPLETE    3 

// The order (controlling index) of a table has changed
#define DBO_CHANGE_ORDER     4 

// A row (record) of a table was changed
#define DBO_TABLE_UPDATE     5 
// A row (record) of a table was deleted
#define DBO_TABLE_DELETED    6 
// A new row (record) was added to a table
#define DBO_TABLE_APPEND     7 

// The record pointer (cursor of a table) will change
#define DBO_MOVE_PROLOG      8 
// The record pointer was changed
#define DBO_MOVE_DONE        9 
// Only after DbGoBottom()
#define DBO_GOBOTTOM        10 
// Only after DbGoTop()
#define DBO_GOTOP           11 

// Reflects changes in DbSetDescend()
#define DBO_ORDER_REVERSED  12

// Reflects changes of rowset due to Filter, Deleted or Scope changes
#define DBO_ROWSET_CHANGED  13

// OrdSetFocus() , SET ORDER TO changes
#define DBO_ORDER_CHANGED   14

// Offset for DBE specific notification messages
#define DBO_NOTIFY_USER   1000 


//
// Defines for Workspace Mamangement/Access
//
// Primary Workspace of Thread
#define DB_WORKSPACE         1 
// Virtual Workspace used to exchange Workareas between Workspaces.
#define DB_ZEROSPACE         2 
// The alert space collects completions of asyncronous database operations.
#define DB_ALERTSPACE        3 

// dmlb.ch is included
#define  _DMLB_CH              

#endif   // #ifndef _DMLB_CH

// * EOF *
